package javax.print;

import javax.print.attribute.Attribute;
import javax.print.attribute.AttributeSet;
import java.awt.GraphicsDevice;
import java.awt.Rectangle;
import java.awt.HeadlessException;
import javax.print.attribute.standard.Fidelity;
import sun.print.SunAlternateMedia;
import javax.print.attribute.standard.Destination;
import sun.print.ServiceDialog;
import java.awt.Dialog;
import java.awt.Frame;
import java.awt.GraphicsEnvironment;
import javax.print.attribute.PrintRequestAttributeSet;
import java.awt.GraphicsConfiguration;

public class ServiceUI
{
    public ServiceUI() {
    }
    
    public static PrintService printDialog(GraphicsConfiguration graphicsConfiguration, int n, int n2, PrintService[] array, PrintService printService, DocFlavor docFlavor, PrintRequestAttributeSet set) throws HeadlessException {
        int n3 = -1;
        if (GraphicsEnvironment.isHeadless()) {
            throw new HeadlessException();
        }
        if (array == null || array.length == 0) {
            throw new IllegalArgumentException("services must be non-null and non-empty");
        }
        if (set == null) {
            throw new IllegalArgumentException("attributes must be non-null");
        }
        if (printService != null) {
            int i = 0;
            while (i < array.length) {
                if (array[i].equals(printService)) {
                    n3 = i;
                    break;
                }
                ++i;
            }
            if (n3 < 0) {
                throw new IllegalArgumentException("services must contain defaultService");
            }
        }
        else {
            n3 = 0;
        }
        __Null locationRelativeTo = null;
        Rectangle union = (graphicsConfiguration == null) ? GraphicsEnvironment.getLocalGraphicsEnvironment().getDefaultScreenDevice().getDefaultConfiguration().getBounds() : graphicsConfiguration.getBounds();
        Object o;
        if ((locationRelativeTo instanceof Frame)) {
            o = new ServiceDialog(graphicsConfiguration, n + union.x, n2 + union.y, array, n3, docFlavor, set, (Frame)locationRelativeTo);
        }
        else {
            o = new ServiceDialog(graphicsConfiguration, n + union.x, n2 + union.y, array, n3, docFlavor, set, (Dialog)locationRelativeTo);
        }
        Rectangle bounds = o.getBounds();
        GraphicsDevice[] screenDevices = GraphicsEnvironment.getLocalGraphicsEnvironment().getScreenDevices();
        for (int j = 0; j < screenDevices.length; ++j) {
            union = union.union(screenDevices[j].getDefaultConfiguration().getBounds());
        }
        if (!union.contains(bounds)) {
            o.setLocationRelativeTo(locationRelativeTo);
        }
        o.show();
        if (o.getStatus() == 1) {
            PrintRequestAttributeSet attributes = o.getAttributes();
            Class<Object> clazz = Destination.class;
            Class<Object> clazz2 = SunAlternateMedia.class;
            Class<Object> clazz3 = Fidelity.class;
            if (set.containsKey(clazz) && !attributes.containsKey(clazz)) {
                set.remove(clazz);
            }
            if (set.containsKey(clazz2) && !attributes.containsKey(clazz2)) {
                set.remove(clazz2);
            }
            set.addAll(attributes);
            Fidelity fidelity = (Fidelity)set.get(clazz3);
            if (fidelity != null && fidelity == Fidelity.FIDELITY_TRUE) {
                removeUnsupportedAttributes(o.getPrintService(), docFlavor, set);
            }
        }
        return o.getPrintService();
    }
    
    private static void removeUnsupportedAttributes(PrintService printService, DocFlavor docFlavor, AttributeSet set) {
        AttributeSet unsupportedAttributes = printService.getUnsupportedAttributes(docFlavor, set);
        if (unsupportedAttributes != null) {
            Attribute[] array = unsupportedAttributes.toArray();
            for (int i = 0; i < array.length; ++i) {
                Class<Object> category = array[i].getCategory();
                if (printService.isAttributeCategorySupported(category)) {
                    Attribute attribute = (Attribute)printService.getDefaultAttributeValue(category);
                    if (attribute != null) {
                        set.add(attribute);
                    }
                    else {
                        set.remove(category);
                    }
                }
                else {
                    set.remove(category);
                }
            }
        }
    }
}
